# -*- coding: utf-8 -*-

from zExceptions import Redirect
from Products.ATContentTypes.content import image
from interfaces import IScalable

def __bobo_traverse__(self, REQUEST, name):
    """Transparent access to image scales
    """
    if name.startswith('image'):
        adapted = IScalable(self)
        if name == 'image':
            url = adapted.getScaleUrl()
            if url:
                raise Redirect, url
        else: 
            scalename = name[len('image_'):]
            adapted = IScalable(self)
            url = adapted.getScaleUrl(scalename)
            if url:
                raise Redirect, url
    return self.__flickr_traverse__(REQUEST,name)

if not hasattr(image.ATImage,'__flickr_traverse__'):
    setattr(image.ATImage,'__flickr_traverse__',image.ATImage.__bobo_traverse__)
    setattr(image.ATImage,'__bobo_traverse__',__bobo_traverse__)


def index_html(self, REQUEST=None, RESPONSE=None):
    """Make it directly viewable when entering the objects URL
    """
    adapted = IScalable(self)
    url = adapted.getScaleUrl()
    if url:
        raise Redirect, url
    return self.__flickr_index_html(REQUEST, RESPONSE)

if not hasattr(image.ATImage,'__flickr_index_html'):
    setattr(image.ATImage,'__flickr_index_html',image.ATImage.index_html)
    setattr(image.ATImage,'index_html',index_html)

